//---------------------------------------------------------------------------

#include <vcl.h>
#include <Registry.hpp>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMain *FormMain;
//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  TRegistry *Registry=new TRegistry;
  if (Registry->OpenKey("Software\\TestRegistry\\",false)==false)
    {
      MessageBox(NULL,"]zOĤ@ϥΥdҡA{N|۰ʫإ߽dҩһݪX\n\nإߪXNb HKEY_CURRENT_USER\\Software\\TestRegistry","ϥ TRegistry",MB_OK);
      Registry->OpenKey("Software\\TestRegistry\\",true);
      Registry->WriteString("ReadString","Test Read String");
      unsigned char ReadBinary[20]={"Test Read BinaryData"};
      Registry->WriteBinaryData("ReadBinaryData",ReadBinary,sizeof(ReadBinary));
      delete ReadBinary;
      Registry->WriteInteger("ReadInteger",800956956);
    };
  delete Registry;

  unsigned char WriteBinary[21]={"Test Write BinaryData"};
  for (int col=0,row=1,data=0; data<21; col++,data++)
    {
      if (col>15)
        {
          WriteBinaryGrid->RowCount=row+2;
          row=row++;
          col=0;
        }
      WriteBinaryGrid->Cells[col][0]=IntToHex(col,2);
      WriteBinaryGrid->Cells[col][row]=IntToHex(WriteBinary[data],2);
    }
 delete WriteBinary;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonReadClick(TObject *Sender)
{
  /* ŧi TRegistry  */
  TRegistry *Registry=new TRegistry;

  /* ]wҭnŪDO
  禡쫬 HKEY RootKey = {read=FRootKey, write=SetRootKey, nodefault};
  HKEY_CLASSES_ROOTBHKEY_CURRENT_USERBHKEY_LOCAL_MACHINEBHKEY_USERSBHKEY_CURRENT_CONFIG
  wɡAw] Rootkey = HKEY_CURRENT_USER;*/
  Registry->RootKey=HKEY_CURRENT_USER;

  /*@]wҭnŪlO
  禡쫬 OpenKey(const AnsiString Key, bool CanCreate);
  ҳ]wlOsbɡA̷ bool ȨMwO_إߤlO ( true = إߤlOAfalse = إߤlO */
  Registry->OpenKey("Software\\TestRegistry\\",false);

  /* Ǧ^ثeҦblO
  禡쫬@HKEY CurrentKey = {read=FCurrentKey, nodefault}; */
  GroupRead->Caption=GroupRead->Caption + "From " + Registry->CurrentPath;

  /* X@ REG_SZ A
  禡쫬@ReadString(const AnsiString Name);*/
  ReadSrting->Text=Registry->ReadString("ReadString");

  /*@X@ REG_BINARY A
  禡쫬@ReadBinaryData(const AnsiString Name, void *Buffer, int BufSize);
  `NGӨƶǦ^Ȭ@REG_BINARY@ƤjpAȤeOǨ@*Buffer@*/
  unsigned short int BinarySize=Registry->GetDataSize("ReadBinaryData");
  unsigned char ReadBinary[20];
  Registry->ReadBinaryData("ReadBinaryData",ReadBinary, BinarySize);
  for (int col=0,row=1,data=0; data<BinarySize; col++,data++)
    {
      if (col>15)
        { ReadBinaryData->RowCount=row+2;
          row=row++;
          col=0;
        }
      ReadBinaryData->Cells[col][0]=IntToHex(col,2);
      ReadBinaryData->Cells[col][row]=IntToHex(ReadBinary[data],2);
    }
   delete ReadBinary;

  /* X@ REG_DWORD A
  禡쫬@ReadInteger(const AnsiString Name);*/
  ReadInteger->Text=IntToHex(Registry->ReadInteger("ReadInteger"),0);

  delete Registry;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonWriteClick(TObject *Sender)
{
  TRegistry *Registry=new TRegistry;
  Registry->OpenKey("Software\\TestRegistry\\",true);
  GroupWrite->Caption=GroupWrite->Caption + "To " + Registry->CurrentPath;
  /* gJ@ REG_SZ A
  禡쫬@WriteString(const AnsiString Name, const AnsiString Value); */
  Registry->WriteString("WriteString","Test Write String");

 /*@gJ@ REG_BINARY A
  禡쫬 WriteBinaryData(const AnsiString Name, void *Buffer, int BufSize);*/
  unsigned char WriteBinary[21]={"Test Write BinaryData"};
  Registry->WriteBinaryData("WriteBinaryData",WriteBinary,sizeof(WriteBinary));
  delete WriteBinary;

  /* X@ REG_DWORD A
  禡쫬 WriteInteger(const AnsiString Name, int Value);*/
  Registry->WriteInteger("WriteInteger",800956956);

  delete Registry;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::EditKeyExistsKeyPress(TObject *Sender,
      char &Key)
{
  /* XO_sb
  禡쫬 KeyExists(const AnsiString Key);*/
  if(Key==0x0D && EditKeyExists->Text!="")
    {
      TRegistry *Registry=new TRegistry;
      Registry->OpenKey("Software\\TestRegistry\\",false);
      if (Registry->KeyExists(EditKeyExists->Text))
        MessageBox(NULL,"KeyExists Success","ϥ TRegistry",MB_OK);
      else MessageBox(NULL,"KeyExists Failure","ϥ TRegistry",MB_OK);
      delete Registry;
  }
}
//---------------------------------------------------------------------------


void __fastcall TFormMain::EditValueExistsKeyPress(TObject *Sender,
      char &Key)
{
  /* ȬO_sb
  禡쫬 ValueExists(const AnsiString Name);*/
  if(Key==0x0D && EditValueExists->Text!="")
    {
      TRegistry *Registry=new TRegistry;
      Registry->OpenKey("Software\\TestRegistry\\",false);
      if (Registry->ValueExists(EditValueExists->Text))
        MessageBox(NULL,"ValueExistss Success","ϥ TRegistry",MB_OK);
      else MessageBox(NULL,"ValueExists Failure","ϥ TRegistry",MB_OK);
      delete Registry;
  }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::EditCreateKeyKeyPress(TObject *Sender,
      char &Key)
{
  /* إ߾X
  禡쫬 CreateKey(const AnsiString Key); */
  if(Key==0x0D && EditCreateKey->Text!="")
    {
      TRegistry *Registry=new TRegistry;
      Registry->OpenKey("Software\\TestRegistry\\",false);
      if (Registry->CreateKey(EditValueExists->Text))
        MessageBox(NULL,"CreateKey Success","ϥ TRegistry",MB_OK);
      else MessageBox(NULL,"CreateKey Failure","ϥ TRegistry",MB_OK);
      delete Registry;
  }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::EditDeleteKeyKeyPress(TObject *Sender,
      char &Key)
{
  /* RX
  禡쫬 DeleteKey(const AnsiString Key);*/
  if(Key==0x0D && EditDeleteKey->Text!="")
    {
      TRegistry *Registry=new TRegistry;
      Registry->OpenKey("Software\\TestRegistry\\",false);
      if (Registry->DeleteKey(EditValueExists->Text))
        MessageBox(NULL,"DeleteKey Success","ϥ TRegistry",MB_OK);
      else MessageBox(NULL,"DeleteKey Failure","ϥ TRegistry",MB_OK);
      delete Registry;
  }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::EditDeleteValueKeyPress(TObject *Sender,
      char &Key)
{
  /* R
  禡쫬 DeleteValue(const AnsiString Name);*/
  if(Key==0x0D && EditDeleteValue->Text!="")
    {
      TRegistry *Registry=new TRegistry;
      Registry->OpenKey("Software\\TestRegistry\\",false);
      if (Registry->DeleteValue(EditDeleteValue->Text))
        MessageBox(NULL,"DeleteValue Success","ϥ TRegistry",MB_OK);
      else MessageBox(NULL,"DeleteValue Failure","ϥ TRegistry",MB_OK);
      delete Registry;
  }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonGetKeyClick(TObject *Sender)
{
  TRegistry *Registry=new TRegistry;
  TStringList *KeyName=new TStringList;
  Registry->OpenKey("Software",false);
  Registry->GetKeyNames(KeyName);
  Label12->Caption="HKEY_CURRENT_USER\\Software\\";
  for (int row=0,data=0; data<KeyName->Count; row++,data++)
    {
      StringGrid->Cells[0][row]=KeyName->Strings[data];
      StringGrid->RowCount=row+1;
    }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonGetValueClick(TObject *Sender)
{
  TRegistry *Registry=new TRegistry;
  TStringList *ValueName=new TStringList;
  Registry->OpenKey("Software\\TestRegistry\\",false);
  Registry->GetValueNames(ValueName);
  for (int row=0,data=0; data<ValueName->Count; row++,data++)
    {
      StringGrid->Cells[0][row]=ValueName->Strings[data];
      StringGrid->RowCount=row+1;
    }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonExitClick(TObject *Sender)
{
  Application->Terminate();
}
//---------------------------------------------------------------------------
